MODULE poincare_modul

  IMPLICIT NONE

CONTAINS

  
  FUNCTION kraft(r) RESULT(F)
    
    DOUBLE PRECISION r(2), x, y, F(2)
    
    x=r(1)
    y=r(2)
    F(1)=-x-2*x*y
    F(2)=-y+y**2-x**2
    
  END FUNCTION kraft



  FUNCTION r_tau(tau,r_a,v_a,F_alt) RESULT(r_n)

    DOUBLE PRECISION tau, r_a(2), v_a(2), F_alt(2), r_n(2)

    r_n= r_a+tau*v_a+tau**2*F_alt/2

  END FUNCTION r_tau



  FUNCTION v_tau(tau, v_a, F_alt, F_neu) RESULT(v_n)

    DOUBLE PRECISION tau, v_a(2), F_alt(2), F_neu(2), v_n(2)

    v_n=v_a+tau*(F_neu+F_alt)/2

  END FUNCTION v_tau


END MODULE poincare_modul


















