SUBROUTINE poincare_verlet_fortran(r,v,poin,anf,tau,iterationen, merken)

  USE poincare_modul
  ! Variablendeklaration

  ! Einegabeparameter
  DOUBLE PRECISION  anf(4), tau
  INTEGER :: iterationen, merken

  ! Ausgabeparameter
  DOUBLE PRECISION  r(iterationen,2), v(iterationen,2), poin(iterationen,2)
 
  ! Interne Variablen
  DOUBLE PRECISION E, x, y, vx, vy, r_neu(2), v_neu(2), F_neu(2), r_alt(2), v_alt(2), F_alt(2), x0, y0
  INTEGER :: i, j, k

  ! Eigentliches Programm
  x=anf(1)
  y=anf(2)
  vx=anf(3)
  vy=anf(4)

  E = 0.5*(X**2+y**2+vx**2+vy**2)+x**2*y-(y**3)/3

  r_alt(1)=x
  r_alt(2)=y

  v_alt(1)=vx
  v_alt(2)=vy

  F_alt=kraft(r_alt)

  j=0
  k=0
  x0=0
  y0=0

  DO i=1,iterationen
     r_neu=r_tau(tau,r_alt,v_alt,F_alt)
     F_neu=kraft(r_neu)
     v_neu=v_tau(tau,v_alt,F_alt,F_neu)
     r_alt=r_neu
     v_alt=v_neu
     F_alt=F_neu
     
     IF (MOD(iterationen, merken) .EQ. 0)  THEN 
        j=j+1
        r(j,:)=r_alt
        v(j,:)=v_alt
     END IF

     IF (SIGN(r_alt(1)) .NE. SIGN(x0)) THEN
        k=k+1
        poin(k,:)=(/r_alt,v_alt,1/)
        x0=r_alt(1)
     END IF

     IF (SIGN(r_alt(2)) .NE. SIGN(y0)) THEN
        k=k+1
        poin(k,:)=(/r_alt,v_alt,2/)
        y0=r_alt(2)
     END IF
     
  END DO

END SUBROUTINE verlet_fortran



