SUBROUTINE poincare_verlet_fortran(r,v,poin,iter,abweichungen,anf,tau,schranke,perioden, merken)

  USE poincare_modul
  ! Variablendeklaration

  ! Einegabeparameter
  DOUBLE PRECISION  anf(4), tau, perioden, merken, schranke
  !INTEGER :: iterationen, merken

  ! Ausgabeparameter
  DOUBLE PRECISION  r(INT(merken),4), v(INT(merken),4), poin(INT(merken),5), iter, abweichungen(INT(merken),1)
 
  ! Interne Variablen
  DOUBLE PRECISION E, x, y, vx, vy, r_n(2), v_n(2), F_neu(2), r_a(2), v_a(2), F_alt(2), x0, y0
  DOUBLE PRECISION tau2, r_n2(2), v_n2(2), F_neu2(2), r_a2(2), v_a2(2), F_alt2(2), abweichung

  INTEGER :: i, j, k

  ! Eigentliches Programm
  x=anf(1)
  y=anf(2)
  vx=anf(3)
  vy=anf(4)

  E = 0.5*(x**2+y**2+vx**2+vy**2)+x**2*y-(y**3)/3

  r_a(1)=x
  r_a(2)=y

  v_a(1)=vx
  v_a(2)=vy

  r_a2(1)=x
  r_a2(2)=y

  v_a2(1)=vx
  v_a2(2)=vy

  F_alt=kraft(r_a)
  F_alt2=kraft(r_a)

  tau2=tau/2

  i=0
  j=0
  k=0

  x0=1.0
  y0=1.0

  DO 
     i=i+1
     r_n=r_tau(tau,r_a,v_a,F_alt)
     F_neu=kraft(r_n)
     v_n=v_tau(tau,v_a,F_alt,F_neu)
     r_a=r_n
     v_a=v_n
     F_alt=F_neu
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     !Probe mit halber Schrittweite
     r_n2=r_tau(tau2,r_a2,v_a2,F_alt2)
     F_neu2=kraft(r_n2)
     v_n2=v_tau(tau2,v_a2,F_alt2,F_neu2)
     r_a2=r_n2
     v_a2=v_n2
     F_alt2=F_neu2
     
     r_n2=r_tau(tau2,r_a2,v_a2,F_alt2)
     F_neu2=kraft(r_n2)
     v_n2=v_tau(tau2,v_a2,F_alt2,F_neu2)
     r_a2=r_n2
     v_a2=v_n2
     F_alt2=F_neu2
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

     abweichung=SQRT((r_a(1)-r_a2(1))**2+(r_a(2)-r_a2(2))**2)
     poin(3,2)=r_a(1)
     poin(3,3)=r_a2(1)
     poin(3,4)=r_a(2)
     poin(3,5)=r_a2(2)

     IF ((j>INT(merken-1)) .OR. (abweichung>schranke)) THEN
        EXIT
     END IF
     
     IF (MOD(i,INT((2*3.14159/tau)/(merken/perioden))) .EQ. 0)  THEN 
        j=j+1
        r(j,1:2)=r_a
        v(j,1:2)=v_a
        r(j,3:4)=r_a2
        v(j,3:4)=v_a2
        abweichungen(j,1)=abweichung          
     END IF
     
     
     IF (r_a(1)*x0 < 0.D0) THEN
        k=k+1
        poin(k,1:5)=(/r_a,v_a,1.D0/)
        x0=r_a(1)
     END IF
     
     IF (r_a(2)*y0 < 0.D0 ) THEN
        k=k+1
        poin(k,:)=(/r_a,v_a,2.D0/)
        y0=r_a(2)
     END IF
     
  END DO

  iter=j*1.0


  !compilieren:  f90 -o poincare_verlet_fortran.x poincare_module.f90 matlab_mod.f90 poincare_verlet_fortran.f90 
  !(Verknpfen von Metro und den Moduls
  
  
  !mex:          mex poincare_verlet_fortran.f90  poincare_modul.f90 poincare_verlet_gate.f90
  ! (Verknpfen vom Gateway Programm mit Fortran Komponenten)


END SUBROUTINE poincare_verlet_fortran



